
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>分布式实时数据处理实战：从选型、应用到优化 / iVAN</title>

    <meta name="description" content="分布式实时数据处理实战：从选型、应用到优化 本文根据DBAplus社群第94期线上分享整理而成.   讲师介绍  卢誉声 Autodesk资深系统研发工程师   &lt;分布式实时处理系统:原理.架构与实现&gt;作者. Hurricane实时处理系统主要贡献者. 多部C++领域译作.   分享大纲:   1. 海量数据处理的挑战 2. 基础处理架构选型 3. 分布式系统结构设计 4. 性能调优和数据存储(MongoDB)   一.海量数据处理的挑战    随着互联网与计算机的普及,我们可以通过传统途径或互联网收集到大量的数据,而在日常工 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">分布式实时数据处理实战：从选型、应用到优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文根据DBAplus社群第94期线上分享整理而成。</p>
<p> </p>
<p>讲师介绍  <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTcvMDMwNy8yMDE3MDMwNzA5NDgyNjYxMS5qcGc=.jpg"><br />卢誉声</p>
<p>Autodesk资深系统研发工程师</p>
<p> </p>
<ul>
<li>《分布式实时处理系统：原理、架构与实现》作者。</li>
<li>Hurricane实时处理系统主要贡献者。</li>
<li>多部C++领域译作。</li>
</ul>
<p> </p>
<p>分享大纲：</p>
<p> </p>
<p>1. 海量数据处理的挑战</p>
<p>2. 基础处理架构选型</p>
<p>3. 分布式系统结构设计</p>
<p>4. 性能调优和数据存储（MongoDB）</p>
<p> </p>
<p>一、海量数据处理的挑战</p>
<p> <br /> </p>
<p>随着互联网与计算机的普及，我们可以通过传统途径或互联网收集到大量的数据，而在日常工作中对这么大量的数据处理需求也与日俱增。日常遇到的数据种类非常多，从结构化的表格数据、到半结构化非结构化的文本图像，我们需要掌握更多的技能与工具来学会如何处理这些数据。尤其在机器学习越来越热的今天，更加有必要学会这个技术。</p>
<p> </p>
<p>近两年最火的恐怕就是深度学习，而深度学习又非常依赖数据量，很多时候不管网络再怎么精心设计，再怎么使用技巧，也不如数据量来得实在。比如在我们这里，就经常需要为此处理大量的文本和图像数据。但在这个过程中，我们发现总是在做很多重复的工作。</p>
<p> </p>
<p>总结一下，日常的工作模式抽象出来基本就是这么几件事：</p>
<p> </p>
<ol>
<li>将需要处理的数据输出到一个列表文件（或者存到数据库里），每一项就是一个任务。</li>
<li>处理程序中开启多个Worker线程，并为每个线程分配任务，线程执行自己的任务，并将结果输出出来。</li>
<li>处理程序还需要记录处理了哪些数据，哪些是成功的，哪些是异常的。</li>
<li>需要将这么多个处理程序连接在一起完成数据处理任务。</li>
</ol>
<p> </p>
<p>二、基础处理架构选型</p>
<p> <br /> </p>
<p>日常工作模式：</p>
<p> </p>
<ul>
<li>为需要处理的数据建立列表</li>
<li>启动程序，开启多个Worker线程处理列表中的数据</li>
<li>将处理完的项目输出到另一个列表中</li>
<li>启动下一个程序，继续开启多个Worker线程处理列表中的数据</li>
<li>……</li>
</ul>
<p> </p>
<p>可以发现，这个需求其实就是一个简单的生产者-消费者模式。我们其实是在建立一个任务队列，然后让Worker来取任务并执行任务。为了简化这项工作，我自己写了一个简单的消息队列以及生产者消费者的抽象，让程序专注于数据处理的逻辑。</p>
<p> </p>
<p>用户只需要建立一个MessageQueue（消息队列），一个Feeder（消息源），一个Consumer（消息处理单元），并且实现Feeder和Consumer的具体逻辑（可以使用函数对象或者lambda表达式）。这样就可以简化日常的任务，但是经过长时间的工作后，发现这样还是远远不够，还需要经常处理以下问题：</p>
<p> </p>
<ul>
<li>如何分配任务？</li>
<li>任务失败了怎么办？</li>
<li>如何保存任务状态？</li>
<li>如何分布式计算？</li>
</ul>
<p> </p>
<p>我们来分别看一看：</p>
<p> </p>
<p>1、如何分配任务？一开始我们采取的是按序号分配任务，每个任务执行连续一批任务。后来发现这样会遇到很多问题，不如使用生产者消费者模式让Worker自己领取任务。但由于缺乏统一的调度者，因此无法确保整体具有最高的计算效率。</p>
<p> </p>
<p>2、如何处理任务失败？我们一开始的方法是将成功任务和失败任务分别放到两个独立列表里，每次一个任务结束后都要重新处理失败的任务，有非常多手动工作。</p>
<p> </p>
<p>3、如何保存任务状态？程序常常会因为各种原因在一半中断（未完全测试的程序可能会内存泄漏、内存越界，即使程序没有问题，也可能发生进程误杀甚至是断电等狗血的事情），因此我们需要保存任务状态，下次启动程序的时候可以自动跳过已经成功处理过的任务。</p>
<p> </p>
<p>4、如何分布式计算？当数据过多时，需要手动分割数据放在几个机器上执行，部署和手动管理成本很高。</p>
<p> </p>
<p>后来我们发现Apache Storm的数据处理方式很适合解决这些问题。但是非常可惜，一方面出于性能考虑，另一方面为了更加容易地调用本地C++程序，这种基于Java的方式并不是那么方便，每次还需要编写JNI来接入我们的C++代码。</p>
<p> </p>
<p>于是，我们需要自己建立一套系统来解决这个问题。这套系统中包含这些东西：</p>
<ol>
<li>使用NodeJS编写的网络爬虫，因为NodeJS单线程异步非阻塞，简化了高性能爬虫的编写工作。</li>
<li>使用MongoDB存储数据，因为MongoDB是文档型数据库，而且可以无模式，处理图像和网页数据的时候非常方便。</li>
<li>使用Caffe来进行训练和数据处理，由于我们的机器并不是特别多，这种情况下Caffe可以提供比Tensorflow更好的性能。</li>
<li>Hurricane实时处理系统( <a href="http://github.com/samblg/hurricane" rel="external nofollow noreferrer">http://github.com/samblg/hurricane</a>或<a href="http://hurricane-project.net/" rel="external nofollow noreferrer">http://hurricane-project.net</a>），是Storm的计算模型在C++11中的实现，不过做了部分简化和调整，以适应我们自己的工作。</li>
</ol>
<p> </p>
<p>三、分布式系统结构设计</p>
<p> <br /> </p>
<p>这里面的关键就是Hurricane这个系统：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTcvMDMwNy8yMDE3MDMwNzA5NDgzOTE2Ny5qcGc=.jpg"></p>
<p> </p>
<p>这张图就是Hurricane的计算模型，Hurricane实时处理系统是一个基于流的分布式实时处理平台，其计算模型是Topology。每个Topology都是一个网络，该网络由计算任务和任务之间的数据流组成。</p>
<p> </p>
<p>该模型中Spout负责产生新的元组，Bolt负责处理前一级任务传递的元组，并将处理过的元组发送给下一级。Spout是元组的生成器，而Bolt则是元组的处理单元。每个任务都会将数据封装为元组传递给其他的任务。</p>
<p> </p>
<p>在系统中任务被定义为Task。Task是对计算任务的统一抽象，规定了计算任务的统一接口。Spout和Bolt都是Task的特殊实现。为了处理这种分布式的计算模型，我们设计了自己的分布式系统架构，如下图所示：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTcvMDMwNy8yMDE3MDMwNzA5NDg1MDM5Ni5qcGc=.jpg"></p>
<p> </p>
<p>最上方的是President，这是整个集群的管理者，负责存储集群的所有元数据，所有Manager都需要与之通信并受其控制。下方的是多个Manager，每个Manager中会包含多个Executor，每个Executor会执行一个任务，可能为Spout和Bolt。</p>
<p> </p>
<p>从任务的抽象角度来讲，每个Executor之间都会相互传递数据，只不过都需要通过Manager完成数据的传递，Manager会帮助Executor将数据以元组的形式传递给其他的Executor。</p>
<p> </p>
<p>Manager之间可以自己传递数据（如果分组策略是确定的），有些情况下还需要通过President来得知自己应该将数据发送到哪个节点中。</p>
<p> </p>
<p>在这个基础架构与计算模型之上，我们还设计了一套上层接口Squared：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTcvMDMwNy8yMDE3MDMwNzA5NDkwNjQ3MS5qcGc=.jpg"></p>
<p> </p>
<p>左侧是Hurricane基本的计算模型，在该计算模型中，系统是一个计算任务组成的网络。我们需要考虑每个节点的琐屑实现。但如果在日常任务中，使用这种模型相对来说会显得比较复杂，尤其当网络非常复杂的时候。</p>
<p> </p>
<p>为了解决这个问题，看一下右边这个计算模型，这是对我们完成计算任务的再次抽象。</p>
<p> </p>
<p>第一步是产生语句的数据源。然后每条语句需要使用名为SplitSentence的函数处理将句子划分为单词。接下来根据单词分组，使用CountWord这个统计操作完成单词的计数。</p>
<p> </p>
<p>所以这个接口的本质是将网络映射成了简单的数据操作流程。解决问题和讨论问题都会变得更为简单直观，现在我们来看看Hurricane的实际应用。</p>
<p> </p>
<p>四、性能调优和数据存储</p>
<p> <br /> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTcvMDMwNy8yMDE3MDMwNzA5NDkxODg2Ny5qcGc=.jpg"></p>
<p> </p>
<p>这是一个数据的预处理任务，我们需要从网络上搜索一堆图片，然后对图片做初步处理（部分检测任务），处理完成后将数据保存在数据库中，作为日后的训练数据使用。</p>
<p> </p>
<p>使用Hurricane后这一切都变得非常简单。我们使用一个Spout读取数据库中的任务，每一个任务是一个词条，第一任务需要使用搜索引擎检索这些词条对应的图像URL。</p>
<p> </p>
<p>这个爬取工作会通过简单的消息队列传给NodeJS，由NodeJS爬取并解析完网页，抽取URL将结果返回给Spout。然后将图像URL保存到数据库中，并传递给下一个任务。</p>
<p> </p>
<p>下一个任务会调度NodeJS将一批图像都爬取并保存下来，这里大家也可以自己使用C++编写获取数据与解析数据的程序，只不过使用JS爬取数据和解析网页比较方便，因此我们把这个任务交给JS完成了。</p>
<p> </p>
<p>完成任务后将图像数据传递给检测器A，检测器A完成检测后将结果和图像送给检测器B，检测器B完成最后检测任务并将数据保存在数据中。最后处理完成的数据和图像经过人工整理后将会作为日后训练数据和测试数据的来源。</p>
<p> </p>
<p>最后就是系统的优化问题了。</p>
<p> </p>
<p>这里很多是实际工程问题，比如在存储大量数据时，由于MongoDB自身支持分布式存储，所以处理起来非常方便。我们只需要设定副本集，然后指定分片的字段就可以建立一个分布式集群，这里比较讲究的就是要根据实际情况选择分片字段。</p>
<p> </p>
<p>和传统开源的MySQL方案相比还是比较简单的，唯一不足就是MongoDB出现过宕机无法恢复的情况，所以日常额外的数据备份工作一定要进行。MongoDB不但自身支持分布式（副本和自动分片），而且还是本人使用过的检索功能最强大的NoSQL数据库之一，日常的许多业务任务都可以使用MongoDB处理。</p>
<p> </p>
<p>日常使用NodeJS配合MongoDB可以快速构建足够健壮的脚本与小型服务，MongoDB也支持对单个文档的原子查找更新，合理设计后可以解决很多问题。</p>
<p> </p>
<p>比如充当简单的任务队列，同时MongoDB中也可以建立全文索引，虽然没有ElasticSearch那么强大，但是已经可以满足简单的需求。最大的优点体现在处理半结构化数据、或者数据模型不确定的时候，比起需要反复修改表结构的关系型数据库来说，MongoDB实在是方便。</p>
<p> </p>
<p>当然MongoDB也存在很多问题：（抛砖引玉，个人感受，如有不当，望大家指正）</p>
<p> </p>
<ol>
<li>统计功能不够强大，虽然有aggregate等功能，但比起关系型数据库来说确实羸弱。</li>
<li>无法实现连表查询，所以在设计数据模型时会和关系型数据库方式不同，也无法完全替代关系型数据库。</li>
<li>不支持事务，虽然MongoDB支持单文档的原子操作，但是无法支持包含多个操作的事务，必须要自己处理这些问题，因此很多有事务要求的系统来说不一定适用。</li>
</ol>
<p> </p>
<p>当然这些只是我在日常处理管理数据中的感受，也恰恰可以适应我们的工作。因为现在数据形式多种多样，需求也多种多样。只不过在我们日常的数据处理过程中，Hurricane配合MongoDB等工具可以更好地流式处理半结构化与非结构化数据。</p>
<p> </p>
<p>最后，一些其他特性：</p>
<p> </p>
<ul>
<li>保序</p>
<p>1）根据顺序处理数据</p>
<p>2）使用Orderld和队列实现保序</li>
<li>多语言支持
<p>1）C</p>
<p>2）Java</p>
<p>3）Python</p>
<p>4）JavaScript</p>
<p> </li>
</ul>
<p>Q&amp;A  <br />Q1：Hurricane系统开源吗？</p>
<p>A1：hurricane real-time processing在Apache协议下开源，可以访问</p>
<p><a href="http://github.com/samblg/hurricane" rel="external nofollow noreferrer">http://github.com/samblg/hurricane</a>。欢迎想了解更多内容和感兴趣的同学参与进来。</p>
<p> </p>
<p>Q2：刚刚大神提到的mongo统计功能的aggregate，我们目前就遇到这问题，数据量并不大，十万左右的数据吧，现在一个统计查询要一秒多这个时间挺吓人的，有没有优化的办法？</p>
<p>A2：aggregate并不是mongo的强项。在编写aggregate语句的时候有许多要注意的，比如对设计到的字段尽可能建立索引，$match或者$sort之类的操作尽量放在整个操作流水线的前面。提前用$match过滤数据，减少后面数据的计算量，排序操作尽量在使用索引的字段上进行等等，如果MongoDB本身优化问题无法解决，那就只能将计算压力放在应用服务器上。尽量少地将数据分片取出到不同的应用服务器上，通过Hurricane这种实时分布式处理系统来完成统计工作，就能很好的解决这类问题---&gt; Hurricane实时处理系统完全开源，不依赖任何第三方库，易于维护和2次开发，相较其他系统，Hurricane 十分轻量级，可维护性高。</p>
<p>原文发布时间为：2017-03-07</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 05:24:06</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/mongodb/" title="mongodb">mongodb</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f%e7%b3%bb%e7%bb%9f/" title="分布式系统">分布式系统</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%a4%84%e7%90%86/" title="数据处理">数据处理</a>, <a href="https://www.iamivan.net/tag/%e6%b6%88%e6%81%af%e9%98%9f%e5%88%97/" title="消息队列">消息队列</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>分布式实时数据处理实战：从选型、应用到优化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPLGrp.html" rel="bookmark">棱镜-分布式实时计算的跟踪校验系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				该文章来自于阿里巴巴技术协会(ATA)精选文章. 摘要:*目前,各种分布式实时计算系统已经在各大互联网公司得到了广泛应用.但是,这些实时系统的计算过程多不进行持久化,如果出现消息丢失等异常情况,通常很难定位问题出现的位置和具体原因,更无法做到主动发现消息丢失.对于广告营销等对消息准确性要求较高的业务场景来说,这种消息丢失的代价通常很高,即便很低的消息丢失率也会造成大量的财物损失.为此,阿里妈妈开发了一套面向分布式实时计算框架storm的实时跟踪校验系统--棱镜系统,棱镜系统实时记录每条消息在st			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M60E8oz.html" rel="bookmark">Apache Eagle：eBay开源分布式实时Hadoop数据安全引擎</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日前,eBay公司隆重宣布正式向开源业界推出分布式实时安全监控方案:Apache Eagle,该项目已于2015年10月26日正式加入Apache基金会成为孵化器项目. http://goeagle.io  Apache Eagle提供一套高效分布式的流式策略引擎,具有高实时.可伸缩.易扩展.交互友好等特点,同时集成机器学习对历史模型训练建立用户画像以实现智能实时地保护Hadoop生态系统中大数据的安全. Eagle在eBay的使用场景 目前,Eagle的数据行为监控系统已经部署到一个拥有250			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqgZrkz.html" rel="bookmark">Apache Eagle：分布式实时 Hadoop 数据安全方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日 前,eBay公司隆重宣布正式向开源业界推出分布式实时安全监控引方案 - Apache Eagle (http://goeagle.io ),该项目已正式加入Apache 称为孵化器项目.Apache Eagle提供一套高效分布式的流式策略引擎,具有高实时.可伸缩.易扩展.交互友好等特点,同时集成机器学习对用户行为建立Profile以实现实时智 能实时地保护Hadoop生态系统中大数据的安全. 背景 随着大数据的发展,越来越多的成功企业或者组织开始采取数据驱动 商业的运作模式.在eBay,我们			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBRK6Nb.html" rel="bookmark">【Spark Summit East 2017】分布式实时流处理：Why and How</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本讲义出自Petr Zapletal在Spark Summit East 2017上的演讲,最近一段时期,流处理的需求增加了很多,需要将不同来源快速增长的大量数据进行处理限制了很多的传统的数据处理基础设施,而很多的开源软件平台开始出现解决这个问题,然而相同的问题会有不同的解决方案,本讲义就探讨了如何对于分布式实时流进行处理.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mym2ZkM.html" rel="bookmark">一脸懵逼学习Storm---（一个开源的分布式实时计算系统）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Storm的官方网址:http://storm.apache.org/index.html 1:什么是Storm? Storm是一个开源的分布式实时计算系统,可以简单.可靠的处理大量的数据流.被称作&quot;实时的hadoop&quot;.Storm有很多使用场景:如实时分析,在线机器学习,持续计算, 分布式RPC,ETL等等.Storm支持水平扩展,具有高容错性,保证每个消息都会得到处理,而且处理速度很快(在一个小集群中,每个结点每秒可以处理 数以百万计的消息).Storm的部署和运维都很便捷,而且更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2kJjb.html" rel="bookmark">&lbrack;原创&rsqb;&period;NET 分布式架构开发实战之四 构建从理想和实现之间的桥梁&lpar;前篇&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[原创].NET 分布式架构开发实战之四 构建从理想和实现之间的桥梁(前篇) .NET 分布式架构开发实战之四 构建从理想和实现之间的桥梁(前篇) 前言:上一篇文章讲述了一些实现DAL的理论,本篇主要是DAL实现的的初步的尝试.   本篇的主要议题如下: 1. 设计DAL的基本操作 2. 对基本的操作的进一步的思考 3. 查询对象的一些思考   系列文章链接:  [原创].NET 分布式架构开发实战之一 故事起源 [原创].NET 分布式架构开发实战之二 草稿设计 [原创].NET 分布式			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR2R1b.html" rel="bookmark">&lbrack;原创&rsqb;&period;NET 分布式架构开发实战之一 故事起源</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[原创].NET 分布式架构开发实战之一 故事起源 .NET 分布式架构开发实战之一 故事起源   前言:本系列文章主要讲述一个实实在在的项目开发的过程,主要包含:提出问题,解决问题,架构设计和各个逻辑层的实现以及新问题的出现和代码的重构.本系列文章以故事的形式展开,而且文章列举的很多项目的名称,大家也不用太关心,很多都是虚拟的.   系列文章链接:  [原创].NET 分布式架构开发实战之一 故事起源 [原创].NET 分布式架构开发实战之二 草稿设计 [原创].NET 分布式架构开发实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQG6np.html" rel="bookmark">&lbrack;原创&rsqb;&period;NET 分布式架构开发实战之二 草稿设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[原创].NET 分布式架构开发实战之二 草稿设计 .NET 分布式架构开发实战之二 草稿设计   前言:本篇之所以称为草稿设计,是因为设计的都是在纸上完成的.反映了一个思考的过程. 本篇的议题如下:   1. 第一个数据层草图的提出 2. 对数据访问层的思考 3. 第二个数据层草图的提出   系列文章链接:  [原创].NET 分布式架构开发实战之一 故事起源 [原创].NET 分布式架构开发实战之二 草稿设计 [原创].NET 分布式架构开发实战之三 数据访问深入一点的思考 [原创].			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjwGW6M.html" rel="bookmark">&lbrack;原创&rsqb;&period;NET 分布式架构开发实战之三 数据访问深入一点的思考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[原创].NET 分布式架构开发实战之三 数据访问深入一点的思考 .NET 分布式架构开发实战之三 数据访问深入一点的思考   前言:首先,感谢园子里的朋友对文章的支持,感谢大家,希望本系列的文章能够真正的对大家起到一点帮助的作用.再次感谢大家.   大家也许想问,什么时候出代码,代码一定会出的,我不想一上来就开始抛出一大堆的代码,然后讲解,架构的设计在思考的过程,思考到了,代码也就水到渠成了.   上篇文章讲述在设计之初,Richard所画出的一些草图,本篇对之前的草图做了进一步的思考.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMl05YM.html" rel="bookmark" class="title">分类网站应该警惕酷讯</a>
					<div>
						媒体最近有一些关于酷讯网(www.kooxoo.com)的报道,这些报道基本有两个主题:一是酷讯网是做分类信息的&quot;垂直搜索&quot;:二是创始人陈华在搜索方面的&quot;资深&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVLYVM.html" rel="bookmark" class="title">Draw2D－－1&period; 设计思想和相关模式</a>
					<div>
						设计 1.  Draw2d 设计思想 Draw2d是一个宿主在SWT Composite控件中的轻量级的构件(widge)系统.一个Draw2d应用程序由一个 SWT Composite控件, 一个轻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz74Rqb.html" rel="bookmark" class="title">怎样看oracle查询语句执行计划&quest;</a>
					<div>
						oracle|语句|执行 SQLPLUS的AutoTrace是分析SQL的执行计划,执行效率的一个非常简单方便的工具,在绝大多数情况下,也是非常有用的工具. 1.如何设置和使用AUTOTRACE SQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEkG3p.html" rel="bookmark" class="title">写软文有麻烦？四招教你轻松搞定</a>
					<div>
						软文写作一直是很多站长最头痛的问题,但是写软文又是站长们做SEO必须学会的技能之一,于是很多站长就被这个软文写作的问题折磨的半死不活.那么到底怎么样才能写出高质量的软文呢? 前几天听到一句话说一个好网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLLZKb.html" rel="bookmark" class="title">第一节：ExtJS调用WCF系列-----实现JSON传递</a>
					<div>
						首先我们打开我们的VS 新建一个Asp.Net WebApplication Project,(不要给我说新建网站,我讨厌那个东东) 命名为ExtJSAndWCFChapter1 如图: 接下来我们在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNamZb.html" rel="bookmark" class="title">Photoshop利用滤镜制作漂亮的大气泡效果</a>
					<div>
						  ps教程         Photoshop利用滤镜制作漂亮的大气泡效果          效果图是由一个简单的光晕经过不断的复制,变形,调色,叠加得到;后期再调整整体颜色,增加对比,局部增加一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kmDAz.html" rel="bookmark" class="title">如何使用ZBrush雕刻生物造型</a>
					<div>
						  如何使用ZBrush3D图形绘制软件的工具和笔刷雕刻酷酷的生物造型,我们今天来看看在游戏.媒体和电视领域有着十几年丰富经验的3D角色艺术家Francis-Xavier Martins是如何操作的: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M918moM.html" rel="bookmark" class="title">PhotoShop打造夕阳中奔跑的场景效果合成教程</a>
					<div>
						在这个教程中我将向你展示如何制作一个漂亮的风景照,光和阴影在本教程中是关键,希望你能掌握它们. photoshop教程最终效果: 1.打开&quot;风景&quot;照片,使用&quot;钢笔工具&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jr04b.html" rel="bookmark" class="title">VB&period;NET面向对象编程特征</a>
					<div>
						  Visual Basic 7也被称作VB.NET,具备了面向对象(OOP)编程语言的所有特征.对于VB编程人员来说,面向对象的概念和面向对象编程方式都不陌生. 如果问一个面向对象程序设计高手什么是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRNqrp.html" rel="bookmark" class="title">人生日历帮你规划暑假出行天气及休息时间</a>
					<div>
						人生日历是驱动人生开发的一款生活应用类软件,不说他功能怎么样,个人感觉这款软件使用起来很贴心,像去年年底的时候,人生日历貌似退出了抢票功能,在这个炎热的夏天,让人生日历来帮你规划你的出行及作息时间吧! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKk05Wb.html" rel="bookmark" class="title">UC浏览器电脑版使用问答</a>
					<div>
						问:UC不是专做手机浏览器的吗? UC浏览器已经全面攻占手机(安卓.iOS.WP.塞班).iPad.aPad.智能电视等终端了.我们的征途是星辰大海,岂能少了电脑版? 问:把手机版做好不就行了? 大了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7N5VM.html" rel="bookmark" class="title">Freehand如何制作螺旋移动的文字动画</a>
					<div>
						  1.双击工具面板中的螺旋工具,在弹出工具的属性面板绘制出螺旋形状.然后使用菜单命令:修改&gt;改变路径&gt;反转方向来改变路径的方向. 2.使用文字工具输入文字&quot;Blueidea.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVKE8b.html" rel="bookmark" class="title">JavaScript函数的4种调用方法详解&lowbar;javascript技巧</a>
					<div>
						在JavaScript中,函数是一等公民,函数在JavaScript中是一个数据类型,而非像C#或其他描述性语言那样仅仅作为一个模块来使用.函数有四种调用模式,分别是:函数调用形式.方法调用形式.构造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPNE8p.html" rel="bookmark" class="title">flash下拉列表&lpar;comboBox&rpar;附源码下载</a>
					<div>
						 代码如下 复制代码 我的经验与您分享 email:mygamemylove@qq.com */ //画矩形 function createRectangle(x:Number, y:Number,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAmBAM.html" rel="bookmark" class="title">动手开发一个名为&OpenCurlyDoubleQuote;微天气&rdquo;的微信小程序（下）</a>
					<div>
						编写逻辑层代码 由于在index.js中还没有设置初始化数据,所以在界面中看不到具体的数据,从而也导致界面的效果没达到设置的要求. 接下来就编写逻辑层代码index.js,为了检查界面设计效果,首先编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRyE0b.html" rel="bookmark" class="title">2017云计算与IT风向标&mdash;&mdash; 移动、转型、整合</a>
					<div>
						更多深度文章,请关注:https://yq.aliyun.com/cloud 风来了,雾霾散尽,再现蓝天,我们渴望持续的风,更关注风向的变化.三句话离不开我们所处的行业,我们也非常关注云风向.粗略分析 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rK4kz.html" rel="bookmark" class="title">jQuery简单创建节点的方法&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery简单创建节点的方法.分享给大家供大家参考,具体如下: &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RJD0z.html" rel="bookmark" class="title">微信屏蔽阿里上市信息 阿里腾讯公关暗战</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 [亿邦动力网讯]阿里巴巴与腾讯的交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zj37z.html" rel="bookmark" class="title">数据库-新手求问，sql中用户对某一视图权力撤回后，要删除该视图吗</a>
					<div>
						问题描述 新手求问,sql中用户对某一视图权力撤回后,要删除该视图吗 新手求问,sql中用户对某一视图权力撤回后,要删除该视图吗.如图所示,题目是撤回杨兰所授予的权力					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYKoRp.html" rel="bookmark" class="title">socket-c语言正则表达式抓取网站的&amp;amp&semi;amp&semi;lt&semi;title&amp;amp&semi;amp&semi;gt&semi;</a>
					<div>
						问题描述 c语言正则表达式抓取网站的&lt;title&gt; 本程序的功能是搜索网站的 字段的值 遗憾的是并不通用:ps:我也不知道为什么失败 问题1:正则表达式或运算消除标签大小写后匹配不到字符串 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodRvVM.html" rel="bookmark" class="title">阿里携手行政执法部门 线上线下联动铁腕打假</a>
					<div>
						4月23日,阿里巴巴集团与公安.质监.版署.知识产权局.工商等政府相关行政执法部门在杭州联合召开&quot;打击假冒伪劣.保护知识产权.共创电子商务健康环境&quot;的深度合作启动仪式发布会. 与会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAE1wQM.html" rel="bookmark" class="title">身份认证-http协议中 是如何确认身份的？</a>
					<div>
						问题描述 http协议中 是如何确认身份的? 用户登录了服务器. 后续的页面请求,服务器如何确认用户的身份? 如何获取这些参数? 解决方案 一个是http基本验证(验证信息放在http头),一个是应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JPamz.html" rel="bookmark" class="title">button  单选-android ListView中的Item有两行Button，要求实现单选效果，应该怎么做呢？</a>
					<div>
						问题描述 android ListView中的Item有两行Button,要求实现单选效果,应该怎么做呢? 就是向这样的Button,在ListView的Item中,如果有两行,要能实现单选效果,应该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq73K2z.html" rel="bookmark" class="title">httpwebrequest-HttpWebRequest能模拟XMLHttpRequest的post请求吗？</a>
					<div>
						问题描述 HttpWebRequest能模拟XMLHttpRequest的post请求吗? 如果能模拟,请问该如何具体实现. HttpWebRequest myRequest = (HttpWebRe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqyl8p.html" rel="bookmark" class="title">C&num;中&comma;如何读取控件的值&comma;进行传递&excl;</a>
					<div>
						问题描述 在我的程序中,有两个页面,一个是login.aspx,另一个database.cs在Login.aspx的TABLE中,有个DropDownList的WEB控件,ID=listShop,它有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg6V0M.html" rel="bookmark" class="title">海尔热水器独特&OpenCurlyDoubleQuote;指上&rdquo;体验，客商和用户印象深刻</a>
					<div>
						2014年3月18日,以&quot;关爱环境享受生活&quot;为主题的第13届中国家电博览会在上海召开.纵观整个家博会,受互联网影响的思维非常明显,&quot;绿色&quot;和&quot;智能&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7nRBb.html" rel="bookmark" class="title">带你走进神秘的谷歌搜索引擎</a>
					<div>
						作为现在的全球使用最广泛搜索引擎,在大众眼中,可能谷歌算法一直披着一层神秘面纱.而谷歌的工程总监斯科特·霍夫曼向我们讲述了在谷歌算法幕后的故事,并且称在2011年有520多项改进,自2003年以后,G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDke3rp.html" rel="bookmark" class="title">聊聊Ajax提交form表单的看法和认识&lowbar;AJAX相关</a>
					<div>
						ajax (ajax开发) AJAX即&quot;Asynchronous Javascript And XML&quot;(异步JavaScript和XML),是指一种创建交互式网页应用的网页开发技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkd7aM.html" rel="bookmark" class="title">jquery siblings获取同辈元素用法实例分析&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery siblings获取同辈元素用法.分享给大家供大家参考,具体如下: jquery siblings 用于获得匹配集合中每个元素的同胞. 语法: .siblings(sele ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NJxVb.html" rel="bookmark" class="title">jQuery编写widget的一些技巧分享&lowbar;jquery</a>
					<div>
						1.在编写widget的时候,一般我们需要绑定一些事件,最好将这些widget的绑定事件加上当前widget的命名空间.如果同一个jQuery对象,使用了两个widget,而两个widget都绑定了相 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
